class Stack {
    _items;
    constructor(items = []) {
        Object.defineProperty(this, "_items", {
            enumerable: false,
            configurable: false,
            writable: false,
            value: items,
        });
    }
    //添加一个新元素到栈顶
    push(element) {
        this._items.unshift(element);
    }
    //移除栈顶元素
    pop() {
        return this._items.shift();
    }
    //返回栈顶元素
    peek() {
        return this._items[0];
    }
    //如果栈里没有任何元素就返回true，否则返回false
    isEmpty() {
        return this._items.length === 0;
    }
    //返回栈里元素个数，类似数组的length
    get size() {
        return this._items.length;
    }
    //将栈结构的内容以字符串的形式返回
    toString() {
        return this._items.toString();
    }
}

class Queue {
    _items;
    constructor(items = []) {
        Object.defineProperty(this, "_items", {
            enumerable: false,
            configurable: false,
            writable: false,
            value: items,
        });
    }
    // 向队列尾部添加一个或多个新的项
    enqueue(...args) {
        this._items.push(...args);
    }
    // 移除队列的第一个项（最前面），并返回被移除的元素
    dequeue() {
        return this._items.shift();
    }
    // 返回队列中第一个元素——最先被添加的项,不改变队列，，类似栈的peek
    front() {
        return this._items[0];
    }
    //  如果队列中不包含任何元素，返回true
    isEmpty() {
        return this._items.length === 0;
    }
    // 返回队列元素个数
    get size() {
        return this._items.length;
    }
    // 将队列中的内容转成字符串形式
    toString() {
        return this._items.join(" ");
    }
}

class NodeItem {
    data;
    next;
    constructor(data) {
        this.data = data;
        this.next = null;
    }
}
class LinkedList {
    head;
    constructor() {
        this.head = null;
    }
    get length() {
        let count = 0;
        let current = this.head;
        if (this.head === null)
            return 0;
        while (current) {
            count++;
            current = current.next;
        }
        return count;
    }
    insert(item, index = this.length) {
        this.judgedIndex(index);
        const nodeItem = new NodeItem(item);
        if (index === 0) {
            const next = this.head?.next || null;
            this.head = nodeItem;
            nodeItem.next = next;
        }
        else {
            let prev = this.getPreviousItem(index);
            nodeItem.next = prev.next?.next || null;
            prev.next = nodeItem;
        }
    }
    find(index) {
        let currentIndex = 0;
        let current = this.head;
        while (current) {
            if (currentIndex === index) {
                return current;
            }
            current = current.next;
            currentIndex++;
        }
    }
    /**
     * 判断输入的index是否合法
     * @param index 索引
     */
    judgedIndex(index) {
        if (index < 0 || index > this.length) {
            throw new Error("index must be a non-negative number no greater than length!");
        }
    }
    getPreviousItem(index) {
        let current = this.head;
        let currentIndex = 0;
        while (current) {
            if (currentIndex === (index - 1)) {
                break;
            }
            current = current.next;
            currentIndex++;
        }
        return current;
    }
}

export { LinkedList, Queue, Stack };
